const chalk = require('chalk')
const { copy, copySync } = require('fs-extra')
const { appConfig } = require('./config')
const path = require('path')

const mkdir = dir => {
  if (!fs.existsSync(dir)) {
    fs.mkdirSync(dir, { recursive: true })
  }
}
const mkdirIfNotExist = () => {
  mkdir(`${TARGET_PATH}/public/env`)
  mkdir(`${TARGET_PATH}/src/components`)
  mkdir(`${TARGET_PATH}/src`)
}

const copyFileToApp = ({ TARGET_PATH }) => {
  // copy files
  console.log(chalk.green(`🥳 Start generate file ...`))
  const packagePath =
    path.dirname(require.resolve(appConfig.packageName)) + '/source-code'

  copySync(`${packagePath}/.husky`, `${TARGET_PATH}/.husky`, {
    overwrite: true
  })
  copySync(`${packagePath}/.vscode`, `${TARGET_PATH}/.vscode`, {
    overwrite: true
  })
  copySync(`${packagePath}/env`, `${TARGET_PATH}/public/env`, {
    overwrite: true
  })
  copySync(`${packagePath}/src`, `${TARGET_PATH}/src`, { overwrite: true })

  copySync(`${packagePath}/.editorconfig`, `${TARGET_PATH}/.editorconfig`, {
    overwrite: true
  })
  copySync(
    `${packagePath}/.env.development`,
    `${TARGET_PATH}/.env.development`,
    {
      overwrite: true
    }
  )
  copySync(`${packagePath}/.env.production`, `${TARGET_PATH}/.env.production`, {
    overwrite: true
  })
  copySync(`${packagePath}/.env.testing`, `${TARGET_PATH}/.env.testing`, {
    overwrite: true
  })
  copySync(`${packagePath}/.env.uat`, `${TARGET_PATH}/.env.uat`, {
    overwrite: true
  })
  copySync(`${packagePath}/.prettierignore`, `${TARGET_PATH}/.prettierignore`, {
    overwrite: true
  })
  copySync(`${packagePath}/.prettierrc`, `${TARGET_PATH}/.prettierrc`, {
    overwrite: true
  })
  copySync(
    `${packagePath}/react-project.config.json`,
    `${TARGET_PATH}/react-project.config.json`,
    { overwrite: true }
  )
  copySync(`${packagePath}/craco.config.js`, `${TARGET_PATH}/craco.config.js`, {
    overwrite: true
  })
  copySync(
    `${packagePath}/tsconfig.paths.json`,
    `${TARGET_PATH}/tsconfig.paths.json`,
    { overwrite: true }
  )
}
module.exports.copyFileToApp = copyFileToApp
